<template>
  <div
    class="image-container height-width-100"
    :style="{ height: messageData?.dimension?.renderedHeight + 'px' }"
  >
    <img
      class="image-item"
      :src="blobFilePath"
      :class="{ 'image-item-show': blobFilePath }"
      @click="showInFullScreen"
    />
    <div
      class="image-skelton-loading height-width-100"
      v-if="!blobFilePath"
    ></div>
    <IonIcon
      @click="emit('downloadMainMediaFile')"
      class="download-icon-file download-state-icon"
      icon="/Images/tabs/messages/download-file-icon.svg"
      color="white"
      v-if="blobFilePath && mainDownloadState == 'requestNotSent'"
    ></IonIcon>
    <IonIcon
      v-if="mainDownloadState == 'downloading'"
      class="download-icon-file downloading-state-icon"
      icon="/Images/tabs/messages/downloading-file-icon.svg"
      color="white"
    ></IonIcon>

    <TimeAndState
      class="state-chat-container-in-image"
      :date="messageData.date"
      :itsMe="messageData.itsMe"
      :status="messageData.status"
    ></TimeAndState>
  </div>
</template>
<script setup>
import { IonIcon, modalController } from '@ionic/vue';
import { defineProps, defineEmits, computed, onMounted } from 'vue';
import FullScreenImageModal from '@/components/message/basics/MessageCard/FullScreenImage.vue';
import TimeAndState from '@/components/message/basics/MessageCard/TimeAndState.vue';
import { useI18n } from 'vue-i18n';

const props = defineProps({
  messageData: {
    type: Object,
    default: () => {
      return {
        id: '',
        itsMe: false,
        type: 'image', // as detecting type for downloading
        date: '',
        status: 'sent',
        editedInfo: {
          isEdited: false,
          date: '',
        },
      };
    },
  },
  blobFilePath: {},
  mainDownloadState: {},
});
const emit = defineEmits(['downloadMainMediaFile']);
const { locale } = useI18n();
const dirIsLtr = computed(() => {
  if (locale.value == 'fa') {
    return true;
  } else {
    return false;
  }
});

const showInFullScreen = async () => {
  if (props.mainDownloadState != 'downloaded') return;
  requestAnimationFrame(async () => {
    const modal = await modalController.create({
      component: FullScreenImageModal,
      componentProps: {
        fileData: {
          path: props.blobFilePath,
          id: props.messageData.id,
        },
        dirIsLtr: !dirIsLtr.value,
      },
    });
    modal.present();
  });
};
onMounted(() => {});
</script>
<style scoped>
.image-container {
  position: relative;
  overflow: hidden;
}

.image-item {
  width: 80vw;
  height: 100%;
  max-height: 40vh;
  opacity: 0;
  transition: 0.5s;
  object-fit: cover;
  display: block;
}
.image-item-show {
  opacity: 1;
}

.image-skelton-loading {
  background-color: var(--card-image-skleton-background);
  position: absolute;
  top: 0;
  left: 0;
}
.image-skelton-loading:after {
  content: '';
  height: 100%;
  width: 50%;
  position: absolute;
  top: 0;
  left: 0;
  transform: translate3d(-100%, 0, 0);
  background-color: var(--card-image-skleton-loader);
  animation-name: skleton-rolling;
  animation-fill-mode: both;
  animation-duration: 1.5s;
  animation-iteration-count: infinite;
  animation-timing-function: ease;
}
@keyframes skleton-rolling {
  0% {
    transform: translate3d(-100%, 0, 0);
  }
  100% {
    transform: translate3d(200%, 0, 0);
  }
}
.download-icon-file {
  position: absolute;
  left: 50%;
  top: 50%;
  width: 50px;
  height: 50px;
  transform: translate(-50%, -50%);
  background-color: var(--card-time-color-in-image);
  border-radius: 50%;
}
.download-state-icon {
  animation-name: scale-in;
  animation-duration: 0.5s;
  animation-timing-function: ease-in-out;
  animation-fill-mode: both;
  animation-iteration-count: 1;
}
@keyframes scale-in {
  0% {
    transform: translate(-50%, -50%) scale(1.5);
  }
  100% {
    transform: translate(-50%, -50%) scale(1);
  }
}
</style>
